// xkeymacsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "xkeymacsDlg.h"
#include "Profile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CXkeymacsDlg dialog


CXkeymacsDlg::CXkeymacsDlg(CWnd *pParent /*=NULL*/)
	: CDialog(CXkeymacsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXkeymacsDlg)
	m_nKillRingMax = 0;
	m_nSettingStyle = -1;
	//}}AFX_DATA_INIT
}


void CXkeymacsDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXkeymacsDlg)
	DDX_Control(pDX, IDC_USE_DIALOG_SETTING, m_cUseDialogSetting);
	DDX_Control(pDX, IDC_CLEAR_ALL, m_cClearAll);
	DDX_Control(pDX, IDC_SELECT_ALL, m_cSelectAll);
	DDX_Control(pDX, IDC_KILL_RING_MAX, m_cKillRingMax);
	DDX_Control(pDX, IDC_RIGHT_ALT, m_cRightAlt);
	DDX_Control(pDX, IDC_LEFT_ALT, m_cLeftAlt);
	DDX_Control(pDX, IDC_ALT, m_cAlt);
	DDX_Control(pDX, IDC_LOAD_DEFAULT, m_cLoadDefault);
	DDX_Control(pDX, IDC_APPLICATION, m_cApplication);
	DDX_Text(pDX, IDC_KILL_RING_MAX, m_nKillRingMax);
	DDV_MinMaxInt(pDX, m_nKillRingMax, 0, 2147483647);
	DDX_Radio(pDX, IDC_SETTING_DEFAULT, m_nSettingStyle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CXkeymacsDlg, CDialog)
	//{{AFX_MSG_MAP(CXkeymacsDlg)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_CBN_SELCHANGE(IDC_APPLICATION, OnSelchangeApplication)
	ON_BN_CLICKED(IDC_CLEAR_ALL, OnClearAll)
	ON_BN_CLICKED(IDC_SELECT_ALL, OnSelectAll)
	ON_BN_CLICKED(IDC_LOAD_DEFAULT, OnLoadDefault)
	ON_CBN_DROPDOWN(IDC_APPLICATION, OnDropdownApplication)
	ON_BN_CLICKED(IDC_CO, OnCo)
	ON_BN_CLICKED(IDC_CO2, OnCo2)
	ON_BN_CLICKED(IDC_SETTING_DEFAULT, OnSettingDefault)
	ON_BN_CLICKED(IDC_SETTING_DISABLE, OnSettingDisable)
	ON_BN_CLICKED(IDC_SETTING_SPECIFIC, OnSettingSpecific)
	ON_BN_CLICKED(IDC_ALT, OnAlt)
	ON_BN_CLICKED(IDC_C_, OnC_)
	ON_BN_CLICKED(IDC_CA, OnCa)
	ON_BN_CLICKED(IDC_CB, OnCb)
	ON_BN_CLICKED(IDC_CBACKSLASH, OnCbackslash)
	ON_BN_CLICKED(IDC_CBACKSLASH_106, OnCbackslash_106)
	ON_BN_CLICKED(IDC_CD, OnCd)
	ON_BN_CLICKED(IDC_CDIGIT, OnCdigit)
	ON_BN_CLICKED(IDC_CE, OnCe)
	ON_BN_CLICKED(IDC_CF, OnCf)
	ON_BN_CLICKED(IDC_CG, OnCg)
	ON_BN_CLICKED(IDC_CH, OnCh)
	ON_BN_CLICKED(IDC_CI, OnCi)
	ON_BN_CLICKED(IDC_CK, OnCk)
	ON_BN_CLICKED(IDC_CL, OnCl)
	ON_BN_CLICKED(IDC_CM, OnCm)
	ON_BN_CLICKED(IDC_CMS5, OnCms5)
	ON_BN_CLICKED(IDC_CN, OnCn)
	ON_BN_CLICKED(IDC_CP, OnCp)
	ON_BN_CLICKED(IDC_CQ, OnCq)
	ON_BN_CLICKED(IDC_CR, OnCr)
	ON_BN_CLICKED(IDC_CS, OnCs)
	ON_BN_CLICKED(IDC_CSLASH, OnCslash)
	ON_BN_CLICKED(IDC_CSPACE, OnCspace)
	ON_BN_CLICKED(IDC_CT, OnCt)
	ON_BN_CLICKED(IDC_CU, OnCu)
	ON_BN_CLICKED(IDC_CV, OnCv)
	ON_BN_CLICKED(IDC_CW, OnCw)
	ON_BN_CLICKED(IDC_CXCC, OnCxcc)
	ON_BN_CLICKED(IDC_CXCF, OnCxcf)
	ON_BN_CLICKED(IDC_CXCJ, OnCxcj)
	ON_BN_CLICKED(IDC_CXCP, OnCxcp)
	ON_BN_CLICKED(IDC_CXCS, OnCxcs)
	ON_BN_CLICKED(IDC_CXCW, OnCxcw)
	ON_BN_CLICKED(IDC_CXU, OnCxu)
	ON_BN_CLICKED(IDC_CY, OnCy)
	ON_BN_CLICKED(IDC_CZ, OnCz)
	ON_BN_CLICKED(IDC_ESCAPE, OnEscape)
	ON_BN_CLICKED(IDC_LEFT_ALT, OnLeftAlt)
	ON_BN_CLICKED(IDC_MB, OnMb)
	ON_BN_CLICKED(IDC_MF, OnMf)
	ON_BN_CLICKED(IDC_MI, OnMi)
	ON_BN_CLICKED(IDC_MS1, OnMs1)
	ON_BN_CLICKED(IDC_MS5, OnMs5)
	ON_BN_CLICKED(IDC_MSCOMMA, OnMscomma)
	ON_BN_CLICKED(IDC_MSPERIOD, OnMsperiod)
	ON_BN_CLICKED(IDC_MV, OnMv)
	ON_BN_CLICKED(IDC_MW, OnMw)
	ON_BN_CLICKED(IDC_MY, OnMy)
	ON_BN_CLICKED(IDC_RIGHT_ALT, OnRightAlt)
	ON_BN_CLICKED(IDC_SQUARE_BRA, OnSquareBra)
	ON_BN_CLICKED(IDC_CXK, OnCxk)
	ON_BN_CLICKED(IDC_MD, OnMd)
	ON_BN_CLICKED(IDC_CXH, OnCxh)
	ON_BN_CLICKED(IDC_CXE, OnCxe)
	ON_BN_CLICKED(IDC_CXS0, OnCxs0)
	ON_BN_CLICKED(IDC_CXS9, OnCxs9)
	ON_BN_CLICKED(IDC_CXB, OnCxb)
	ON_BN_CLICKED(IDC_CXCT, OnCxct)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXkeymacsDlg message handlers

BOOL CXkeymacsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	SetForegroundWindow();

	InitApplicationList();

	CProfile::LoadRegistryData();
	m_szCurrentApplication.LoadString(IDS_DEFAULT);
	SetDialogData(m_szCurrentApplication);
	EnableUseDefaultButton(FALSE);
	m_cLoadDefault.EnableWindow(FALSE);

	OSVERSIONINFO verInfo = {0};
	verInfo.dwOSVersionInfoSize = sizeof (verInfo);
	GetVersionEx(&verInfo);

	switch (verInfo.dwPlatformId) {
	case VER_PLATFORM_WIN32_NT:
		m_cLeftAlt.ShowWindow(SW_SHOWNA);
		m_cRightAlt.ShowWindow(SW_SHOWNA);
		m_cAlt.ShowWindow(SW_HIDE);
		break;

	case VER_PLATFORM_WIN32_WINDOWS:
		m_cLeftAlt.ShowWindow(SW_HIDE);
		m_cRightAlt.ShowWindow(SW_HIDE);
		m_cAlt.ShowWindow(SW_SHOWNA);
		break;

	default:
		AfxMessageBox(IDS_ERR_WINDOWS_VERSION);
		return 0;
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CXkeymacsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	CProfile::LoadRegistryData();
	
	CDialog::OnCancel();
}

void CXkeymacsDlg::OnApply() 
{
	// TODO: Add your control notification handler code here
	GetDialogData();
	CProfile::SaveRegistryData();
}

void CXkeymacsDlg::OnOK() 
{
	// TODO: Add extra validation here
	OnApply();
	
	CDialog::OnOK();
}

// set dialog data
void CXkeymacsDlg::SetDialogData(CString szApplicationName)
{
	UpdateDialogData(szApplicationName, FALSE);
	UpdateData(FALSE);
}

// get dialog Data
void CXkeymacsDlg::GetDialogData()
{
	UpdateData();
	if (m_nSettingStyle == SETTING_DEFAULT) {
		CProfile::ClearData(m_szCurrentApplication);
	} else {
		UpdateDialogData(m_szCurrentApplication, TRUE);
	}
}

// set/get dialog data
void CXkeymacsDlg::UpdateDialogData(CString szApplicationName, BOOL bSaveAndValidate)
{
	int nApplicationID = CProfile::GetApplicationIndex(szApplicationName, bSaveAndValidate, &m_nSettingStyle);
	if (nApplicationID == MAX_APP) {
		if (!bSaveAndValidate) {
			SetAllDialogData(1);
		}
		return;
	}

	if (!bSaveAndValidate) {	// SetDialogData
		EnableControl();
	}
	if (CProfile::IsDefault(szApplicationName) ||
		CProfile::IsDialog(szApplicationName)) {
		EnableUseDefaultButton(FALSE);
	} else {
		EnableUseDefaultButton(TRUE);
	}

	// application title
	CProfile::UpdateApplicationTitle(&m_cApplication, m_szCurrentApplication, nApplicationID, bSaveAndValidate);

	// on/off
	if (!bSaveAndValidate) {	// SetDialogData
		SetAllDialogData(1);
		CheckDlgButton(IDC_CO2, BST_CHECKED);
		InitChanged(FALSE);
	}
	for (int nCommandID = 0; ; ++nCommandID) {
		CString szCommandName = CXkeymacsData::GetCommandName(nCommandID);
		if (szCommandName.IsEmpty()) {
			break;
		}

		for (int i = 0; ; ++i) {
			int nCommandType = CXkeymacsData::GetDefaultCommandType(nCommandID, i);
			int nKey = CXkeymacsData::GetDefaultCommandKey(nCommandID, i);
			int nControlID = CXkeymacsData::GetDefaultControlID(nCommandID, i);
			if (nKey == 0) {
				break;
			}
			if (bSaveAndValidate) {	// GetDialogData
				if (nControlID == IDC_CO2) {
					continue;
				}
				if (!m_bChanged[nCommandID]) {
					continue;
				}
				if (IsDlgButtonChecked(nControlID)) {
					CProfile::SetCommandID(nApplicationID, nCommandType, nKey, nCommandID);
				} else {
					CProfile::SetCommandID(nApplicationID, nCommandType, nKey, 0);
				}
			} else {				// SetDialogData
				if (nCommandID != CProfile::GetCommandID(nApplicationID, nCommandType, nKey)) {
					CheckDlgButton(nControlID, BST_UNCHECKED);
				}
			}
		}
	}
	// only for Toggle Imput Method Editor C-o: Canna mode
	if (bSaveAndValidate) {	// GetDialogData
		int nCommandType = CONTROL;
		int nKey = 'O';
		if (CProfile::GetCommandID(nApplicationID, nCommandType, nKey) == 0) {
			if (IsDlgButtonChecked(IDC_CO2)) {
				for (int nCommandID = 0; ; ++nCommandID) {
					CString szCommandName = CXkeymacsData::GetCommandName(nCommandID);
					if (szCommandName.IsEmpty()) {
						break;
					}
					if (!szCommandName.CompareNoCase("toggle-input-method")) {
						CProfile::SetCommandID(nApplicationID, nCommandType, nKey, nCommandID);
						CProfile::SetCommandID(nApplicationID, CONTROL+SHIFT, nKey, nCommandID);
						break;
					}
				}
			}
		}
	}

	// kill-ring-max
	if (bSaveAndValidate) {	// GetDialogData
		CProfile::SetKillRingMax(nApplicationID, m_nKillRingMax);
	} else {				// SetDialogData
		m_nKillRingMax = CProfile::GetKillRingMax(nApplicationID);
	}

	// Use Dialog Setting
	if (bSaveAndValidate) {	// GetDialogData
		CProfile::SetUseDialogSetting(nApplicationID, m_cUseDialogSetting.GetCheck() == BST_CHECKED);
	} else {				// SetDialogData
		m_cUseDialogSetting.SetCheck(CProfile::GetUseDefaultSetting(nApplicationID) ? BST_CHECKED : BST_UNCHECKED);
	}
}

// initiate application name combo box
void CXkeymacsDlg::InitApplicationList()
{
	CProfile::InitApplicationList(&m_cApplication);
}

void CXkeymacsDlg::OnSelchangeApplication() 
{
	// TODO: Add your control notification handler code here
	GetDialogData();

	CProfile::GetApplicationTitle(&m_cApplication, m_szCurrentApplication, m_cApplication.GetCurSel());
	int nStart;
	if ((nStart = m_szCurrentApplication.ReverseFind('(')) != -1) {
		++nStart;
		m_szCurrentApplication =
			m_szCurrentApplication.Mid(nStart, m_szCurrentApplication.GetLength() - nStart - 1);
	}

	m_cLoadDefault.EnableWindow(TRUE);
	SetDialogData(m_szCurrentApplication);
	if (CProfile::IsDefault(m_szCurrentApplication)) {
		m_cLoadDefault.EnableWindow(FALSE);
	}
}

void CXkeymacsDlg::OnClearAll() 
{
	// TODO: Add your control notification handler code here
	SetAllDialogData(0);
	InitChanged(TRUE);
}

void CXkeymacsDlg::OnSelectAll() 
{
	// TODO: Add your control notification handler code here
	SetAllDialogData(1);
	InitChanged(TRUE);
}

// set all dialog data
void CXkeymacsDlg::SetAllDialogData(UINT nCheck)
{
	for (int nCommandID = 0; ; ++nCommandID) {
		CString szCommandName = CXkeymacsData::GetCommandName(nCommandID);
		if (szCommandName.IsEmpty()) {
			break;
		}

		for (int i = 0; ; ++i) {
			int nKey = CXkeymacsData::GetDefaultCommandKey(nCommandID, i);
			int nControlID = CXkeymacsData::GetDefaultControlID(nCommandID, i);
			if (nKey == 0) {
				break;
			}
			CheckDlgButton(nControlID, nCheck);
		}
	}
	CheckDlgButton(IDC_CO2, BST_UNCHECKED);
}

void CXkeymacsDlg::OnLoadDefault() 
{
	// TODO: Add your control notification handler code here
	CString szDefault;
	szDefault.LoadString(IDS_DEFAULT);
	CProfile::CopyData(m_szCurrentApplication, szDefault);
	SetDialogData(m_szCurrentApplication);
}

void CXkeymacsDlg::OnCo()
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CO);
	if (IsDlgButtonChecked(IDC_CO) == BST_CHECKED) {
		CheckDlgButton(IDC_CO2, BST_UNCHECKED);
		Changed(IDC_CO2);
	}
}

void CXkeymacsDlg::OnCo2()
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CO2);
	if (IsDlgButtonChecked(IDC_CO2) == BST_CHECKED) {
		CheckDlgButton(IDC_CO, BST_UNCHECKED);
		Changed(IDC_CO);
	}
}

void CXkeymacsDlg::OnSettingDefault() 
{
	// TODO: Add your control notification handler code here
	UpdateData();	// get data
	EnableControl();
}

void CXkeymacsDlg::OnSettingDisable() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	EnableControl();
}

void CXkeymacsDlg::OnSettingSpecific() 
{
	// TODO: Add your control notification handler code here
	UpdateData();
	EnableControl();

	if (CProfile::GetApplicationIndex(m_szCurrentApplication) == MAX_APP) {
		CString szDefault;
		szDefault.LoadString(IDS_DEFAULT);
		CProfile::CopyData(m_szCurrentApplication, szDefault);
		SetDialogData(m_szCurrentApplication);
	}
}

// set control enable/disable
void CXkeymacsDlg::EnableControl()
{
	BOOL bEnableWindow = (m_nSettingStyle == SETTING_SPECIFIC);

	for (int nCommandID = 0; ; ++nCommandID) {
		CString szCommandName = CXkeymacsData::GetCommandName(nCommandID);
		if (szCommandName.IsEmpty()) {
			break;
		}

		for (int i = 0; ; ++i) {
			int nKey = CXkeymacsData::GetDefaultCommandKey(nCommandID, i);
			int nControlID = CXkeymacsData::GetDefaultControlID(nCommandID, i);
			if (nKey == 0) {
				break;
			}
			if (GetDlgItem(nControlID)) {
				GetDlgItem(nControlID)->EnableWindow(bEnableWindow);
			}
		}
	}
	m_cKillRingMax.EnableWindow(bEnableWindow);
	m_cLoadDefault.EnableWindow(bEnableWindow);
	m_cSelectAll.EnableWindow(bEnableWindow);
	m_cClearAll.EnableWindow(bEnableWindow);

	m_cUseDialogSetting.EnableWindow(bEnableWindow);
	if (CProfile::IsDialog(m_szCurrentApplication)) {
		m_cUseDialogSetting.EnableWindow(FALSE);
	}
}

// enable Use Default Setting button
void CXkeymacsDlg::EnableUseDefaultButton(BOOL bEnable)
{
	if (GetDlgItem(IDC_SETTING_DEFAULT)) {
		GetDlgItem(IDC_SETTING_DEFAULT)->EnableWindow(bEnable);
	}
}

void CXkeymacsDlg::OnDropdownApplication() 
{
	// TODO: Add your control notification handler code here
	InitApplicationList();

	int nID = GetCurrentApplicationID();
	if (nID != CB_ERR) {
		m_cApplication.SetCurSel(nID);
	} else {
		GetDialogData();
		m_szCurrentApplication.LoadString(IDS_DEFAULT_TITLE);
		m_cApplication.SelectString(-1, m_szCurrentApplication);
		SetDialogData(m_szCurrentApplication);
	}
}

int CXkeymacsDlg::GetCurrentApplicationID()
{
	return CProfile::GetCurrentApplicationID(&m_cApplication, m_szCurrentApplication);
}

void CXkeymacsDlg::OnAlt() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_ALT);
}

void CXkeymacsDlg::OnC_() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_C_);
}

void CXkeymacsDlg::OnCa() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CA);
}

void CXkeymacsDlg::OnCb() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CB);
}

void CXkeymacsDlg::OnCbackslash() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CBACKSLASH);
}

void CXkeymacsDlg::OnCbackslash_106() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CBACKSLASH_106);
}

void CXkeymacsDlg::OnCd() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CD);
}

void CXkeymacsDlg::OnCdigit() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CDIGIT);
}

void CXkeymacsDlg::OnCe() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CE);
}

void CXkeymacsDlg::OnCf() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CF);
}

void CXkeymacsDlg::OnCg() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CG);
}

void CXkeymacsDlg::OnCh() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CH);
}

void CXkeymacsDlg::OnCi() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CI);
}

void CXkeymacsDlg::OnCk() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CK);
}

void CXkeymacsDlg::OnCl() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CL);
}

void CXkeymacsDlg::OnCm() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CM);
}

void CXkeymacsDlg::OnCms5() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CMS5);
}

void CXkeymacsDlg::OnCn() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CN);
}

void CXkeymacsDlg::OnCp() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CP);
}

void CXkeymacsDlg::OnCq() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CQ);
}

void CXkeymacsDlg::OnCr() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CR);
}

void CXkeymacsDlg::OnCs() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CS);
}

void CXkeymacsDlg::OnCslash() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CSLASH);
}

void CXkeymacsDlg::OnCspace() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CSPACE);
}

void CXkeymacsDlg::OnCt() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CT);
}

void CXkeymacsDlg::OnCu() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CU);
}

void CXkeymacsDlg::OnCv() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CV);
}

void CXkeymacsDlg::OnCw() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CW);
}

void CXkeymacsDlg::OnCxcc() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCC);
}

void CXkeymacsDlg::OnCxcf() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCF);
}

void CXkeymacsDlg::OnCxcj() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCJ);
}

void CXkeymacsDlg::OnCxcp() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCP);
}

void CXkeymacsDlg::OnCxcs() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCS);
}

void CXkeymacsDlg::OnCxcw() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCW);
}

void CXkeymacsDlg::OnCxu() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXU);
}

void CXkeymacsDlg::OnCy() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CY);
}

void CXkeymacsDlg::OnCz() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CZ);
}

void CXkeymacsDlg::OnEscape() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_ESCAPE);
}

void CXkeymacsDlg::OnLeftAlt() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_LEFT_ALT);
}

void CXkeymacsDlg::OnMb() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MB);
}

void CXkeymacsDlg::OnMf() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MF);
}

void CXkeymacsDlg::OnMi() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MI);
}

void CXkeymacsDlg::OnMs1() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MS1);
}

void CXkeymacsDlg::OnMs5() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MS5);
}

void CXkeymacsDlg::OnMscomma() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MSCOMMA);
}

void CXkeymacsDlg::OnMsperiod() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MSPERIOD);
}

void CXkeymacsDlg::OnMv() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MV);
}

void CXkeymacsDlg::OnMw() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MW);
}

void CXkeymacsDlg::OnMy() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MY);
}

void CXkeymacsDlg::OnRightAlt() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_RIGHT_ALT);
}

void CXkeymacsDlg::OnSquareBra() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_SQUARE_BRA);
}

void CXkeymacsDlg::Changed(int nObjectID)
{
	for (int nCommandID = 0; ; ++nCommandID) {
		CString szCommandName = CXkeymacsData::GetCommandName(nCommandID);
		if (szCommandName.IsEmpty()) {
			break;
		}

		for (int i = 0; ; ++i) {
			if (CXkeymacsData::GetDefaultCommandKey(nCommandID, i) == 0) {
				break;
			}

			int nControlID = CXkeymacsData::GetDefaultControlID(nCommandID, i);
			if ((nControlID == nObjectID) ||
				((nObjectID == IDC_CO) && (nControlID == IDC_CO2)) ||
				((nObjectID == IDC_CO2) && (nControlID == IDC_CO))) {
				m_bChanged[nCommandID] = TRUE;
			}
		}
	}
}

void CXkeymacsDlg::InitChanged(BOOL bChanged)
{
	for (int i = 0; i < sizeof(m_bChanged)/sizeof(m_bChanged[0]); ++i) {
		if (CXkeymacsData::GetDefaultControlID(i, 0) || !bChanged) {
			m_bChanged[i] = bChanged;
		}
	}
}

void CXkeymacsDlg::OnCxk() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXK);
}

void CXkeymacsDlg::OnMd() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_MD);
}

void CXkeymacsDlg::OnCxh() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXH);
}

void CXkeymacsDlg::OnCxe() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXE);
}

void CXkeymacsDlg::OnCxs0() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXS0);
}

void CXkeymacsDlg::OnCxs9() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXS9);
}

void CXkeymacsDlg::OnCxb() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXB);
}

void CXkeymacsDlg::OnCxct() 
{
	// TODO: Add your control notification handler code here
	Changed(IDC_CXCT);
}
